unit FdesGLst;

interface

uses
  FDesTool, FDesGAdd, FdesGChg, FdesGDel,
  WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Menus, Dialogs;

type
  TDlgGrpLst = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    GrpList: TListBox;
    MainMenu: TMainMenu;
    MnuEdit: TMenuItem;
    MnuEditAdd: TMenuItem;
    MnuEditChg: TMenuItem;
    MnuEditDel: TMenuItem;
    PopupMenu: TPopupMenu;
    PopAdd: TMenuItem;
    PopChange: TMenuItem;
    PopDelete: TMenuItem;
    BitBtn1: TBitBtn;
    DlgGrpFont: TFontDialog;
    Options1: TMenuItem;
    MnuOptionsFont: TMenuItem;
    Toolbar: TPanel;
    BtnAdd: TSpeedButton;
    BtnChange: TSpeedButton;
    BtnDelete: TSpeedButton;
    BtnFont: TSpeedButton;
    procedure MnuEditAddClick(Sender: TObject);
    procedure MnuEditChgClick(Sender: TObject);
    procedure MnuEditDelClick(Sender: TObject);
    procedure MnuEditClick(Sender: TObject);
    procedure PopupMenuPopup(Sender: TObject);
    procedure MnuOptionsFontClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DlgGrpFontApply(Sender: TObject; Wnd: Word);
  private
  public
    Changed : boolean;
    procedure AdjustButtons;
    procedure ApplyFont;
  end;

var
  DlgGrpLst: TDlgGrpLst;

implementation
Uses StfLib, FdesMain;

{$R *.DFM}

procedure TDlgGrpLst.AdjustButtons;
begin
  BtnChange.Enabled:= GrpList.ItemIndex > -1;
  BtnDelete.Enabled:= GrpList.ItemIndex > -1;
end;

procedure TDlgGrpLst.ApplyFont;
begin
  GrpList.Font := DlgGrpFont.Font;
end;

procedure TDlgGrpLst.MnuEditAddClick(Sender: TObject);
var i: integer;
begin with DlgGrpAdd, GrpList do begin
  TxtGroup.Text:= '';
  ActiveControl:= TxtGroup;
  if (DlgGrpAdd.ShowModal = mrOK) and
     (StfRTS(TxtGroup.Text) <> '') then begin
    i:= Items.Add(TxtGroup.Text);
    if  i > -1 then begin
      ItemIndex:= i;
      Changed:= true;
    end;
  end;
end; end;

procedure TDlgGrpLst.MnuEditChgClick(Sender: TObject);
var i: integer;
begin with DlgGrpChg, GrpList do if ItemIndex > -1 then begin
  TxtGroup.Text:= StfRTS(Items[ItemIndex]);
  ActiveControl:= TxtGroup;
  if (DlgGrpChg.ShowModal = mrOK) and
     (StfRTS(TxtGroup.Text) <> '') then begin
    Items.Delete(ItemIndex);
    i:= Items.Add(TxtGroup.Text);
    if i > -1 then GrpList.ItemIndex:= i;
    Changed:= true;
  end;
end; end;

procedure TDlgGrpLst.MnuEditDelClick(Sender: TObject);
begin with DlgGrpDel, GrpList do if ItemIndex > -1 then begin
  TxtGroup.Caption:= StfRTS(Items[ItemIndex]);
  ActiveControl:= OKBtn;
  if DlgGrpDel.ShowModal = mrOK then begin
    Items.Delete(ItemIndex);
    Changed:= true;
  end;
end; end;

procedure TDlgGrpLst.MnuEditClick(Sender: TObject);
begin
  MnuEditChg.Enabled:= GrpList.ItemIndex > -1;
  MnuEditDel.Enabled:= GrpList.ItemIndex > -1;
end;

procedure TDlgGrpLst.PopupMenuPopup(Sender: TObject);
begin
  PopChange.Enabled:= GrpList.ItemIndex > -1;
  PopDelete.Enabled:= GrpList.ItemIndex > -1;
end;

procedure TDlgGrpLst.MnuOptionsFontClick(Sender: TObject);
begin
  DlgGrpFont.Font:= GrpList.Font;
  if DlgGrpFont.Execute then
    ApplyFont;
end;

procedure TDlgGrpLst.FormCreate(Sender: TObject);
begin GrpList.Font:= MainWnd.GrpLstFont; end;

procedure TDlgGrpLst.DlgGrpFontApply(Sender: TObject; Wnd: Word);
begin
  ApplyFont;
end;

end.
